Index: monasca-api-2.2.1.dev9/monasca_tempest_tests/tests/api/helpers.py
===================================================================
--- monasca-api-2.2.1.dev9.orig/monasca_tempest_tests/tests/api/helpers.py
+++ monasca-api-2.2.1.dev9/monasca_tempest_tests/tests/api/helpers.py
@@ -1,4 +1,5 @@
 # (C) Copyright 2015 Hewlett Packard Enterprise Development Company LP
+# (C) Copyright SUSE LLC
 #
 # Licensed under the Apache License, Version 2.0 (the "License"); you may
 # not use this file except in compliance with the License. You may obtain
@@ -133,36 +134,46 @@ def get_expected_elements_inner_offset_l
     total_statistics = 0
 
     if offset is None:
-        offset_id = 0
+        offset_id = None
         offset_time = ""
+        passed_offset = True
     else:
         offset_tuple = offset.split('_')
-        offset_id = int(offset_tuple[0]) if len(offset_tuple) > 1 else 0
+        offset_id = offset_tuple[0] if len(offset_tuple) > 1 else u'0'
         offset_time = offset_tuple[1] if len(offset_tuple) > 1 else offset_tuple[0]
+        passed_offset = False
 
     for element in all_elements:
-        element_id = int(element['id'])
-        if offset_id is not None and element_id < offset_id:
+        element_id = element['id']
+        if (not passed_offset) and element_id != offset_id:
             continue
         next_element = None
-        for value in element[inner_key]:
-            if (element_id == offset_id and value[0] > offset_time) or \
-                    element_id > offset_id:
 
+        for value in element[inner_key]:
+            if passed_offset or (element_id == offset_id and value[0] > offset_time):
+                if not passed_offset:
+                    passed_offset = True
                 if not next_element:
                     next_element = element.copy()
                     next_element[inner_key] = [value]
                 else:
                     next_element[inner_key].append(value)
                 total_statistics += 1
-            if total_statistics >= limit:
-                break
+                if total_statistics >= limit:
+                    break
+
         if next_element:
             expected_elements.append(next_element)
+
         if total_statistics >= limit:
             break
 
-    for i in range(len(expected_elements)):
-        expected_elements[i]['id'] = str(i)
+        if element_id == offset_id:
+            passed_offset = True
+
+    # if index is used in the element id, reset to start at zero
+    if expected_elements and expected_elements[0]['id'].isdigit():
+        for i in range(len(expected_elements)):
+            expected_elements[i]['id'] = str(i)
 
     return expected_elements
Index: monasca-api-2.2.1.dev9/monasca_tempest_tests/tests/api/test_dimensions.py
===================================================================
--- monasca-api-2.2.1.dev9.orig/monasca_tempest_tests/tests/api/test_dimensions.py
+++ monasca-api-2.2.1.dev9/monasca_tempest_tests/tests/api/test_dimensions.py
@@ -1,4 +1,5 @@
 # (C) Copyright 2016 Hewlett Packard Enterprise Development LP
+# (C) Copyright 2017 SUSE LLC
 #
 # Licensed under the Apache License, Version 2.0 (the "License"); you may
 # not use this file except in compliance with the License. You may obtain
@@ -75,9 +76,14 @@ class TestDimensions(base.BaseMonascaTes
             resp, response_body = cls.monasca_client.list_metrics(
                 param)
             elements = response_body['elements']
+            metric_name1_count = 0
             for element in elements:
                 returned_name_set.add(str(element['name']))
-            if cls._test_metric_names.issubset(returned_name_set):
+                if (str(element['name']) == metric_name1):
+                    metric_name1_count += 1
+            # Java version of influxdb never returns both metric1 in the list but Python does.
+            if cls._test_metric_names.issubset(returned_name_set) \
+                    and (metric_name1_count == 2 or i == constants.MAX_RETRIES - 1):
                 return
             time.sleep(constants.RETRY_WAIT_SECS)
 
Index: monasca-api-2.2.1.dev9/monasca_tempest_tests/tests/api/test_statistics.py
===================================================================
--- monasca-api-2.2.1.dev9.orig/monasca_tempest_tests/tests/api/test_statistics.py
+++ monasca-api-2.2.1.dev9/monasca_tempest_tests/tests/api/test_statistics.py
@@ -1,4 +1,5 @@
 # (C) Copyright 2015-2016 Hewlett Packard Enterprise Development LP
+# (C) Copyright 2017 SUSE LLC
 #
 # Licensed under the Apache License, Version 2.0 (the "License"); you may
 # not use this file except in compliance with the License. You may obtain
@@ -238,7 +239,7 @@ class TestStatistics(base.BaseMonascaTes
             resp, response_body = self.monasca_client.list_metrics(query_parms)
             self.assertEqual(200, resp.status)
             elements = response_body['elements']
-            if elements:
+            if elements and len(elements) == num_metrics:
                 break
             else:
                 time.sleep(constants.RETRY_WAIT_SECS)
